// WPGear. admin_fields_control.js

// Управление дополнительными полями: 

// - Запрет отображения на Фронтенд/Excel.



window.addEventListener ('load', function() {

	console.log('admin_fields_control.js - is loaded');	

	

	var FieldsBox_ContentChanged_Processing = false;

	var Fields_Control_Box_Name = 'gvxlpro-gv-field-admin-info-limits-box';

	var Inputs_CustomClass;

	var Inputs_ExcelHeaders;

	var FieldsBox = document.getElementById('directory-active-fields');

	

	if (FieldsBox) {

		// Инициализация.

		FieldsBox_ContentChanged();

	}	

	

	FieldsBox.addEventListener('DOMSubtreeModified', FieldsBox_ContentChanged, false);



	// Вылавливаем Добавление Новых Полей или прочие Изменения.

	function FieldsBox_ContentChanged() {

		if (FieldsBox_ContentChanged_Processing == true) {

			return;

		}

		

		var FieldsBox_Items = FieldsBox.querySelectorAll('[class$="gv-fields"]');

		var Fields_Control_Box;

		var Fields_Control_BoxName;

		var Item_Options_Box_CustomClass_Field;

		

		var i;

		var j;	

		

		for (i = 0; i < FieldsBox_Items.length; i++) {

			var Item_Options_Box_NoEditable_Field = null;

			var Item_Options_Box_GFReadOnly_Field = null;

		

			Item_Options_Box_CustomClass_Field = FieldsBox_Items[i].querySelectorAll('[name$="[custom_class]"]')[0];

			Item_Options_Box_ExcelHeader_Field = FieldsBox_Items[i].querySelectorAll('[name$="[excel_header]"]')[0];			

			Item_Options_Box_NoEditable_Field = FieldsBox_Items[i].querySelectorAll('[name$="[no_editable]"]')[1];

			

			if (Item_Options_Box_NoEditable_Field) {

				Item_Options_Box_GFReadOnly_Field = Item_Options_Box_NoEditable_Field.nextElementSibling;

			}



			if (Item_Options_Box_CustomClass_Field) {

				var NoFrontend;

				var NoExcel;

								

				NoFrontend 	= get_class_in_customclassfield(Item_Options_Box_CustomClass_Field.value, 'no_frontend');

				NoExcel 	= get_class_in_customclassfield(Item_Options_Box_CustomClass_Field.value, 'no_excel');



				var ExcelHeader;

				ExcelHeader = Item_Options_Box_ExcelHeader_Field.value;



				for (j = 0; j < FieldsBox_Items[i].childNodes.length; j++) {

					if (FieldsBox_Items[i].childNodes[j].nodeName == "H5") {

						// В зависимости от набора AddOn's GV, нужный узел может быть на разных уровнях

						Fields_Control_Box = FieldsBox_Items[i].childNodes[j].childNodes[1];

						

						Fields_Control_BoxName = Fields_Control_Box.getAttribute('name');

					

						if (Fields_Control_BoxName != Fields_Control_Box_Name) {

							FieldsBox_ContentChanged_Processing = true;



							// LimitsBox

							var Node_LimitsBox 	= document.createElement("span");

							var Attribute_Name 	= document.createAttribute("name");

							var Attribute_Class = document.createAttribute("class");



							Attribute_Name.value 	= Fields_Control_Box_Name; 

							Attribute_Class.value 	= "gvxlpro-gv-field-admin-info-limits-box";



							Node_LimitsBox.setAttributeNode(Attribute_Name); 

							Node_LimitsBox.setAttributeNode(Attribute_Class);    



							// NoFrontend

							var Node_LimitsBox_NoFrontend = document.createElement("span");

							Node_LimitsBox.appendChild(Node_LimitsBox_NoFrontend);



							var Icon_NoFrontend = document.createElement("i");

							Node_LimitsBox_NoFrontend.appendChild(Icon_NoFrontend);



							var Attribute_Name 		= document.createAttribute("name");

							Attribute_Name.value 	= "gvxlpro-gv-field-admin-info-limits-nofrontend"; 

							Node_LimitsBox_NoFrontend.setAttributeNode(Attribute_Name); 



							var Attribute_Class 	= document.createAttribute("class");

							if (NoFrontend) {

								Attribute_Class.value 	= "gvxlpro-gv-field-admin-info-limits-on";

							} else {

								Attribute_Class.value 	= "gvxlpro-gv-field-admin-info-limits-off";

							}

							Node_LimitsBox_NoFrontend.setAttributeNode(Attribute_Class);



							var Attribute_Style 	= document.createAttribute("style");

							Attribute_Style.value 	= "margin-left: 4px; margin-right: 9px;";

							Node_LimitsBox_NoFrontend.setAttributeNode(Attribute_Style);



							var Attribute_Title 	= document.createAttribute("title");

							Attribute_Title.value 	= "Frontend. Click for change.";

							Node_LimitsBox_NoFrontend.setAttributeNode(Attribute_Title);



							var Attribute_Class 	= document.createAttribute("class");

							Attribute_Class.value 	= "fa fa-television"; 

							Icon_NoFrontend.setAttributeNode(Attribute_Class);



							Node_LimitsBox_NoFrontend.setAttribute("onclick", "bso_admin_gv_field_toggle_option (event, 'no_frontend');");



							// NoExcel

							var Node_LimitsBox_NoExcel = document.createElement("span");

							Node_LimitsBox.appendChild(Node_LimitsBox_NoExcel);



							var Icon_NoExcel = document.createElement("i");

							Node_LimitsBox_NoExcel.appendChild(Icon_NoExcel);



							var Attribute_Name 	= document.createAttribute("name");

							Attribute_Name.value 	= "gvxlpro-gv-field-admin-info-limits-noexcel";

							Node_LimitsBox_NoExcel.setAttributeNode(Attribute_Name); 



							var Attribute_Class = document.createAttribute("class");

							if (NoExcel) {

								Attribute_Class.value 	= "gvxlpro-gv-field-admin-info-limits-on";

							} else {

								Attribute_Class.value 	= "gvxlpro-gv-field-admin-info-limits-off";

							}

							Node_LimitsBox_NoExcel.setAttributeNode(Attribute_Class);



							var Attribute_Style 	= document.createAttribute("style");

							Attribute_Style.value 	= "margin-right: 9px;";

							Node_LimitsBox_NoExcel.setAttributeNode(Attribute_Style); 



							var Attribute_Title = document.createAttribute("title");

							Attribute_Title.value 	= "Excel-Export. Click for change.";

							Node_LimitsBox_NoExcel.setAttributeNode(Attribute_Title);



							var Attribute_Class 	= document.createAttribute("class");

							Attribute_Class.value 	= "fa fa-file-excel-o"; 

							Icon_NoExcel.setAttributeNode(Attribute_Class); 



							Node_LimitsBox_NoExcel.setAttribute("onclick", "bso_admin_gv_field_toggle_option (event, 'no_excel');");



							// ExcelHeader

							var Node_LimitsBox_ExcelHeader = document.createElement("span");

							Node_LimitsBox.appendChild(Node_LimitsBox_ExcelHeader);



							var Attribute_Class = document.createAttribute("class");

							Attribute_Class.value 	= "gvxlpro-gv-field-admin-info-excel_header"; 

							Node_LimitsBox_ExcelHeader.setAttributeNode(Attribute_Class); 

							

							var Attribute_Title = document.createAttribute("title");

							Attribute_Title.value 	= "Alternative Column-Name for Excel.";

							Node_LimitsBox_ExcelHeader.setAttributeNode(Attribute_Title);



							var Text_ExcelHeader = document.createTextNode(ExcelHeader);						

							Node_LimitsBox_ExcelHeader.appendChild(Text_ExcelHeader);

							

							// All Together!

							FieldsBox_Items[i].childNodes[j].childNodes[0].insertAdjacentElement("afterend", Node_LimitsBox);

						}					

					}

				}

			} 

		}



		FieldsBox_ContentChanged_Processing	= false;

			

		Inputs_CustomClass = document.querySelectorAll('[name$="[custom_class]"]');

		CustomClass_Fields_Events();

		

		Inputs_ExcelHeaders = document.querySelectorAll('[name$="[excel_header]"]');

		ExcelHeader_Fields_Events();

	}

	

	// Проверяем наличие проверяемого Класса.

	function get_class_in_customclassfield (CustomClass, ClassName) {

		var CustomClass_Array = CustomClass.split(" ");

		var Result = false;	

		

		for (k = 0; k < CustomClass_Array.length; k++) { 

			if (CustomClass_Array[k] == ClassName) {

				Result = true;

			}				

		}



		return Result;

	}

	

	// Изменение Поля: CustomClass.

	function CustomClass_Fields_Events () {

		for (i = 0; i < Inputs_CustomClass.length; i++) { 

			Inputs_CustomClass[i].onchange = function(e) {

				// console.log(e);

				

				var CustomClass = e.target.value;

				

				var NoFrontend = false;

				var NoExcel = false;

				

				NoFrontend 	= get_class_in_customclassfield(CustomClass, 'no_frontend');

				NoExcel 	= get_class_in_customclassfield(CustomClass, 'no_excel');				

				

				var Item_Path = e.path;

				var Fields_Control_Box;

				

				for (j = 0; j < Item_Path[6].childNodes.length; j++) {			

					if (Item_Path[6].childNodes[j].nodeName == "H5") {

						// В зависимости от набора AddOn's GV, нужный узел может быть на разных уровнях				

						Fields_Control_Box = Item_Path[6].childNodes[j].childNodes[1];

						

						if (Fields_Control_Box.getAttribute('name') == Fields_Control_Box_Name) {

							// Ранее Сохраненное Поле

							if (NoFrontend) {

								Item_Path[6].childNodes[j].childNodes[1].children[0].className = 'gvxlpro-gv-field-admin-info-limits-on';

							} else {

								Item_Path[6].childNodes[j].childNodes[1].children[0].className = 'gvxlpro-gv-field-admin-info-limits-off';

							}

							

							if (NoExcel) {

								Item_Path[6].childNodes[j].childNodes[1].children[1].className = 'gvxlpro-gv-field-admin-info-limits-on';

							} else {

								Item_Path[6].childNodes[j].childNodes[1].children[1].className = 'gvxlpro-gv-field-admin-info-limits-off';

							}					

						} else {

							// Свежедобавленное Поле. Странно!					

						}						

					}

				}

			};		

		}		

	}



	// Изменение Поля: ExcelHeader.	

	function ExcelHeader_Fields_Events () {

		for (i = 0; i < Inputs_ExcelHeaders.length; i++) { 

			Inputs_ExcelHeaders[i].onchange = function(e) {

				// console.log(e);

				

				var ExcelHeader = e.target.value;

				

				var Item_Path = e.path;

				var Fields_Control_Box;

				

				for (j = 0; j < Item_Path[6].childNodes.length; j++) {			

					if (Item_Path[6].childNodes[j].nodeName == "H5") {

						// В зависимости от набора AddOn's GV, нужный узел может быть на разных уровнях				

						Fields_Control_Box = Item_Path[6].childNodes[j].childNodes[1];

						

						if (Fields_Control_Box.getAttribute('name') == Fields_Control_Box_Name) {

							// Ранее Сохраненное Поле

							Item_Path[6].childNodes[j].childNodes[1].children[2].innerHTML = ExcelHeader;					

						} else {

							// Свежедобавленное Поле. Странно!					

						}						

					}

				}				

			};

		}

	}



});



// Переключаем: NoFrontend / NoExcel

function bso_admin_gv_field_toggle_option (e, Target) {

	e.preventDefault();

	

	var Item_Path = e.path;

	var Item_FieldFormID 	= Item_Path[4].getElementsByClassName("field-form-id")[0];	// name="fields[directory_table-columns][5fe9cf9ef3d5e][form_id]"

	var Item_Options 		= Item_Path[4].getElementsByClassName("gv-dialog-options")[0];

	var Item_Options_CustomClass = Item_Options.getElementsByClassName("gv-setting-container-custom_class")[0];

	var Item_Options_CustomClass_Input = Item_Options_CustomClass.getElementsByTagName('input')[0];

	

	var Item_Class = e.srcElement.parentElement;



	// может быть множество Классов

	if (Item_Options_CustomClass_Input.value) {

		var CustomClass_Array = Item_Options_CustomClass_Input.value.split(" ");				

		

		var Item_Options_CustomClass_Value = '';

		var Target_Detected = false;

		var i;

		

		for (i = 0; i < CustomClass_Array.length; i++) { 

			if (CustomClass_Array[i] != Target) {

				if (Item_Options_CustomClass_Value != '') {

					Item_Options_CustomClass_Value = Item_Options_CustomClass_Value + ' ';

				}

				

				Item_Options_CustomClass_Value = Item_Options_CustomClass_Value + CustomClass_Array[i];

			} else {

				Target_Detected = true;

			}

		}

		

		if (Target_Detected == false) {

			Item_Options_CustomClass_Value = Item_Options_CustomClass_Value + ' ' + Target;

		}

		

	} else {

		Item_Options_CustomClass_Value = Target;

	}

	

	Item_Options_CustomClass_Input.value = Item_Options_CustomClass_Value;

	

	Item_Class.classList.toggle("gvxlpro-gv-field-admin-info-limits-on");	

	Item_Class.classList.toggle("gvxlpro-gv-field-admin-info-limits-off");

	

	console.log(Target);

}